#include <stdbool.h>
#include <stdio.h>
#include "nrf.h"
#include "bsp.h"
//#include "app_uart.h"
#include "app_error.h"
#include "nordic_common.h"

#define SIZE_PAGE		(uint32_t) NRF_FICR->CODEPAGESIZE
#define COUNT_PAGE			44
#define START_SAVE_ADRESS (uint32_t *)(SIZE_PAGE * NUM_PAG)

#define MAX_TABLE_ADDR 550
#define MAX_SIZE_BLOCK 32
#define FLASH_EMPTY_MASK    0xFFFFFFFF                          /**< Bit mask that defines an empty address in flash. */

typedef struct
{
		uint32_t   pg_size;
    uint32_t   pg_num;
		uint32_t   num_page;
		uint32_t * start_addr;
		uint32_t * end_addr;
		uint32_t * table_addr;
		
	

} flash_param;

struct nrf51_info {
	uint32_t code_page_size;
	uint32_t code_memory_size;

	bool probed;
	struct target *target;
};

typedef enum{
	
  MODE_CONFIG = 0,
  MODE_ERASE = 1,
  MODE_READ = 2,
  MODE_WRITE = 3,
  MODE_ALL_ERASE = 4 

}MODE_FLASH;

/**@brief flash param*/
/*typedef struct
{
		pstorage_handle_t       handle;
		pstorage_handle_t				block_handle[COUNT_BLOCK];
		pstorage_module_param_t param;
		uint8_t                 send_data[SIZE_BLOCK];
		uint16_t 								lastBlock;			
		uint16_t								sizeWriteFlash;
		uint32_t                retval;
} ble_flash_trekers_p;*/

uint32_t flash_read(uint32_t *address);
void flash_page_erase(uint32_t * page_address);
void flash_word_write(uint32_t * address, uint32_t value);
void ui_format_all_flash(void);

//my function for Flash
uint32_t ui_flash_table_init(void);//       
uint32_t ui_flash_save_data(uint32_t num_block, uint8_t * p_in_array, uint16_t size);//  (   ) 
uint32_t ui_get_page_for_Block(uint32_t  num_block);//    ,    
uint32_t ui_read_all_data_from_page(uint32_t num_page, uint32_t * p_out_array);//      
void ui_flash_format_current_page(uint32_t num_page);//  
uint32_t ui_falsh_read_data_from_block(uint32_t num_block, uint8_t * p_out_array, uint16_t size); //      

uint32_t	ui_flash_update(uint32_t num_block, uint8_t * p_in_array, uint16_t size);//    
uint32_t	ui_flash_save(uint32_t num_block, uint8_t * p_in_array, uint16_t size);//    
uint32_t ui_flash_verify(uint32_t num_block);//     
void ui_format_all_flash(void);//  
uint32_t	ui_flash_clear_block(uint32_t num_block);//   


